// ConaitoObject.cpp: implementation of the CConaitoObject class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "vcsample.h"
#include "ConaitoObject.h"
#include "VCSampleDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CConaitoObject::CConaitoObject()
{

}

CConaitoObject::~CConaitoObject()
{

}


void CConaitoObject::ErrorMessage()
{
	DWORD dwError = GetLastError();

	CWnd* pParentWnd = AfxGetMainWnd();
	
	if(dwError == 10)
	{
		pParentWnd->MessageBox("You are not online, please click the 'Online' button first to make and/or receive the calls", "Online", MB_ICONEXCLAMATION);
	}

	else if(dwError == 11)
	{
		pParentWnd->MessageBox("You are already in the conversation, please disconnect it first", "Already connected", MB_ICONEXCLAMATION);
	}

	else if(dwError == 12)
	{
		pParentWnd->MessageBox("Already connecting, please disconnect it first", "Already connecting", MB_ICONEXCLAMATION);
	}

	else if(dwError == 13)
	{
		pParentWnd->MessageBox("Cann't access Input/Mic device or device is already in use", "Input Device Problem", MB_ICONEXCLAMATION);
	}

	else if(dwError == 14)
	{
		pParentWnd->MessageBox("Cann't access Output/Speaker device or device is already in use", "Output Device Problem", MB_ICONEXCLAMATION);
	}
	
	else if(dwError == 15)
	{
		pParentWnd->MessageBox("Invalid UniqueId to Accept the call", "Incoming Call", MB_ICONEXCLAMATION);
	}

	else if(dwError == 16)
	{
		pParentWnd->MessageBox("Cannot open local communication port or Port is already in use", "Local Port Error", MB_ICONEXCLAMATION);
	}

	else if(dwError == 17)
	{
		pParentWnd->MessageBox("Invalid License Key", "License Key", MB_ICONEXCLAMATION);
	}

	else if(dwError == 18)
	{
		pParentWnd->MessageBox("Failed to connect to Proxy Server", "Proxy Server Error", MB_ICONEXCLAMATION);
	}

	else if(dwError == 19)
	{
		pParentWnd->MessageBox("Registration failed to Proxy Server", "Proxy Server Error", MB_ICONEXCLAMATION);
	}

	else if(dwError == 20)
	{
		pParentWnd->MessageBox("Register yourself to Proxy Server first by providing a Unique Id", "Proxy Server Error", MB_ICONEXCLAMATION);
	}

	else if(dwError == 21)
	{
		pParentWnd->MessageBox("Already adding into the conference", "Conference", MB_ICONEXCLAMATION);
	}
	
	else if(dwError == 22)
	{
		pParentWnd->MessageBox("Already in the conversation", "Conversation", MB_ICONEXCLAMATION);
	}
	
	else if(dwError == 23)
	{
		pParentWnd->MessageBox("Please start the conversation first by clicking 'Start Conversation' button, then you can add more persons into the conversation", "Conference", MB_ICONEXCLAMATION);
	}

	else if(dwError == 24)
	{
		pParentWnd->MessageBox("Unique Id is not in the conversation", "Unique Id does not exist", MB_ICONEXCLAMATION);
	}
}


void CConaitoObject::OnStatusEvent(DWORD dwStatusCode, CString sFromUniqueId)
{
	
	CWnd* pCallStatusWnd = AfxGetMainWnd()->GetDlgItem(IDC_STATIC_CALLSTATUS);
		
	switch (dwStatusCode)
	{
		case 50:
			pCallStatusWnd->SetWindowText("Failed to connect to " + sFromUniqueId);
			break;
		
		case 51:
			pCallStatusWnd->SetWindowText("Connecting to " + sFromUniqueId + "....");
			break;

		case 52:
			pCallStatusWnd->SetWindowText("Connection to " + sFromUniqueId + "lost, please try again");
			break;

		case 53:
			pCallStatusWnd->SetWindowText("Successfully connected to " + sFromUniqueId);
			break;

		case 54:
			pCallStatusWnd->SetWindowText("Connection closed by " + sFromUniqueId);
			break;

		case 55:
			pCallStatusWnd->SetWindowText(sFromUniqueId + " is busy");
			break;

		case 56:
			pCallStatusWnd->SetWindowText(sFromUniqueId + " is not available");
			break;

		case 57:
			pCallStatusWnd->SetWindowText("Call cancelled by " + sFromUniqueId);
			break;

		case 58:
			pCallStatusWnd->SetWindowText("Connection to Proxy Server lost");
			break;

		case 59:
			pCallStatusWnd->SetWindowText(sFromUniqueId + " is already in conversation");
			break;

		case 60:
			pCallStatusWnd->SetWindowText("Adding " + sFromUniqueId + " in the conference");
			break;

		case 61:
			pCallStatusWnd->SetWindowText("Successfully Added " + sFromUniqueId + " in the conference");
			break;

		case 62:
			pCallStatusWnd->SetWindowText(sFromUniqueId + " has cancelled the add conference request");
			break;

		case 63:
			pCallStatusWnd->SetWindowText("Adding " + sFromUniqueId + " in conference failed");
			break;
	}
}

void CConaitoObject::OnTextEvent(CString sTextMsg, CString sFromUniqueId)
{
	CVCSampleDlg* pParentWnd = (CVCSampleDlg*) AfxGetMainWnd();

	pParentWnd->m_ReceiveTxtListBox.AddString(sFromUniqueId + ": " + sTextMsg);

}


void CConaitoObject::OnConnectionEvent(CString sFromUniqueId)
{
	CVCSampleDlg* pParentWnd = (CVCSampleDlg*) AfxGetMainWnd();
	
	if(pParentWnd->MessageBox("You have an incoming call, Do you want to accept?", "Incoming call from Unique ID: " + sFromUniqueId, MB_ICONEXCLAMATION|MB_YESNO) == IDYES)
	{
		if(!AcceptIncomingCall(sFromUniqueId, 20))
		{
			ErrorMessage();
		}
	}
	else
	{
		if(!CancelIncomingCall(sFromUniqueId))
		{
			ErrorMessage();
		}
	}


}


void CConaitoObject::OnAddConferenceEvent(CString sFromUniqueId)
{
	CVCSampleDlg* pParentWnd = (CVCSampleDlg*) AfxGetMainWnd();
	
	if(pParentWnd->MessageBox("You have an incoming ADD Conference Request, Do you want to accept?", "Add Conference from Unique ID: " + sFromUniqueId, MB_ICONEXCLAMATION|MB_YESNO) == IDYES)
	{
		if(!AcceptAddConfRequest(sFromUniqueId, 20))
		{
			ErrorMessage();
		}
	}
	else
	{
		if(!CancelAddConfRequest(sFromUniqueId))
		{
			ErrorMessage();
		}
	}
}


void CConaitoObject::OnServerTextEvent(CString sTextMsg)
{
	CVCSampleDlg* pParentWnd = (CVCSampleDlg*) AfxGetMainWnd();

	pParentWnd->m_ListMsgFromServerReceive.AddString(sTextMsg);
}

void CConaitoObject::OnWhisperEvent(CString sUniqueId, CString sTextMsg)
{
	CVCSampleDlg* pParentWnd = (CVCSampleDlg*) AfxGetMainWnd();

	pParentWnd->m_ReceiveWhisperList.AddString(sUniqueId + ": " + sTextMsg);
}



